

#include <stdio.h>
#include <string.h>
#include <ctype.h>

int bit7 = 0;
int ctrlg = 0;
int verbose = 0;

int esc_found;
char * escptr;
char escbuf[30];
char special_ch;

int colour = 0x07;

outchar(ch)
int ch;
{
   ch &= 0xFF;

   /* Completely ignore ^@ ^S ^Q */
   if( ch == '\0' || ch == '\021' || ch == '\023' ) return;

   if( esc_found || isprint(ch) || (ch&0x80) )
   {
      if( esc_found )
      {
         *escptr++ = ch;
	 if( !isascii(ch) || !isgraph(ch) || escptr == escbuf+1 )
	 {
	    if( ch != '[' )
	    {
	       escptr--; *escptr = '\0';
	       litprt('\033');
	       for(escptr=escbuf; *escptr; escptr++)
	          litprt(*escptr);
	       esc_found = 0;
	       outchar(ch);
	    }
	 }
         else if( ch >= '@' && ch <= '~' )
	 {
            *escptr = '\0';
            if( escbuf[0] == '[' )
	       do_ansi(ch+(special_ch<<8));
            esc_found = 0;
         }
	 else if( ch != ';' && (ch < '0' || ch > '9') )
	    special_ch = ch;
      }
      else
         litprt(ch);
   }
   else if( ch == '\033' )
   {
      esc_found = 1;
      escptr = escbuf;
      special_ch = 0;
   }
   else if( ch == '\r' || ch == '\n' || ch == '\b'
	 || ch == '\t' || ch == '\007' )
      putchar(ch);
   else
      litprt(ch);
}

do_ansi(ch)
int ch;
{
   int cnt;
   int cnt1;
   char * p;

   switch(ch)
   {
   case 'm': break;
   case 'A': case 'B': case 'C': case 'D':
   case 'H': case 'J': case 'K':
   case 'f': case 's': case 'u':
         printf("\033%s", escbuf);
         return;
   case 'G':
	 cnt = atoi(escbuf+1);
	 strcpy(escbuf, "[80D");
         printf("\033%s", escbuf);
	 if( cnt > 1 )
	 {
	    sprintf(escbuf, "[%dC", cnt-1);
            printf("\033%s", escbuf);
	 }
	 return;
   default:
	 if( verbose )
	 {
            litprt('\033');
            p= escbuf;
	    while(*p) litprt(*p++);
	 }
         return;
   }

   escptr = escbuf;
   while( escptr )
   {
      cnt = atoi(escptr+1);
      switch(cnt)
      {
      case 0: colour  = 0x07; break;
      case 1: colour |= 0x08; break;
      case 5: colour |= 0x80; break;
      case 7: colour  = 0x70; break;
      case 30: case 31: case 32: case 33:
      case 34: case 35: case 36: case 37:
     	 colour = ((colour&0xF8)|(cnt-30));
     	 break;
      case 40: case 41: case 42: case 43:
      case 44: case 45: case 46: case 47:
     	 colour = ((colour&0x8F)|((cnt-40)<<4));
     	 break;
      }
      escptr = strchr(escptr+1, ';');
   }
   set_colour(colour);
}

set_colour(colour)
int colour;
{
static int last_colour = -1;
   if( colour == -1 )
   {
      colour = last_colour;
      printf("\033[m");
      last_colour = 0x07;
      if( colour == -1 ) colour = last_colour;
   }
   colour &= 0xFF;
   if( colour != last_colour)
   {
      if( ((last_colour & ~colour) & 0x88) != 0 )
      {
         printf("\033[m");
         last_colour = 0x07;
      }
      if( (last_colour & 0x08) == 0
       && (colour & 0x08) != 0)
      {
         printf("\033[1m");
         last_colour |= 0x08;
      }
      if( (last_colour & 0x80) == 0
       && (colour & 0x80) != 0)
      {
         printf("\033[5m");
         last_colour |= 0x80;
      }
      if( (last_colour & 0x07) != (colour &0x07) )
      {
         printf("\033[3%dm", colour&0x07);
      }
      if( (last_colour & 0x70) != (colour &0x70) )
      {
         printf("\033[4%dm", ((colour&0x70)>>4));
      }
      last_colour = colour;
   }
}

litprt(ch)
int ch;
{
static char chartab[] = "CueaaaaceeeiiiAAE**ooouuyOUc$YPsaiounNao?++**!<>###||||..||.'''.`--|-+||`.--|-+----``..++'.#****aBTPEsyt******EN=+><++-=...*n2* ";
   ch &=0xFF;
   if( ch & 0x80 )
   {
      if( !bit7 ) { putchar(ch); return; }
      ch &= 0x7F;
      if( verbose ) printf("M-");
      else          ch = chartab[ch];
   }
   if( isprint(ch) )
      putchar(ch);
   else if( ch == '\007' && ctrlg )
      putchar(ch);
   else if( verbose )
   {
      putchar('^');
      putchar(ch ^ '@');
   }
}


char buf[2048];
FILE * fd;

main(argc, argv)
int argc;
char ** argv;
{
   int ch, cc, i, fc;

   fc = 0;
   for(i=1; i<argc; i++) if( argv[i][0] == '-' )
   {
      switch(argv[i][1])
      {
      case '7': bit7 = 1; break;
      case 'g': ctrlg = 1; break;
      case 'v': verbose = 1; break;
      }
   }
   else
   {
      fd = fopen(argv[i], "r");
      fc++;
      if( fd )
      {
	 while((ch=getc(fd))!=EOF)
	    outchar(ch);
         fclose(fd);
      }
      else
	 fprintf(stderr, "Cannot open %s\n", argv[i]);
   }
   if( fc==0 )
   {
      while((cc=read(0,buf,sizeof(buf))) > 0)
      {
         for(i=0; i<cc; i++)
            outchar(buf[i]);
         fflush(stdout);
      }
   }
}
